"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var lang_1 = require("@angular/core/src/facade/lang");
var fonticon_service_1 = require('../services/fonticon.service');
var TNSFontIconPipe = (function () {
    function TNSFontIconPipe(fonticon, _ref) {
        this.fonticon = fonticon;
        this._ref = _ref;
    }
    TNSFontIconPipe.prototype.transform = function (className, args) {
        var _this = this;
        var collectionName;
        if (args && args.length && args[0] !== null) {
            collectionName = args[0];
        }
        else if (className && className.indexOf('-') > -1) {
            // derive from classname
            collectionName = className.split('-')[0];
        }
        else {
            // font collection name is required
            return this.value;
        }
        // if there is a subscription to iconSub, clean it
        this._dispose();
        this.iconSub = this.fonticon.filesLoaded.subscribe(function (data) {
            if (data[collectionName] && data[collectionName][className]) {
                _this.value = data[collectionName][className];
                _this._ref.markForCheck();
            }
        });
        return this.value;
    };
    TNSFontIconPipe.prototype._dispose = function () {
        if (lang_1.isPresent(this.iconSub)) {
            this.iconSub.unsubscribe();
            this.iconSub = undefined;
        }
    };
    TNSFontIconPipe.prototype.ngOnDestroy = function () {
        this._dispose();
    };
    TNSFontIconPipe = __decorate([
        core_1.Pipe({
            name: 'fonticon',
            pure: false
        }), 
        __metadata('design:paramtypes', [fonticon_service_1.TNSFontIconService, core_1.ChangeDetectorRef])
    ], TNSFontIconPipe);
    return TNSFontIconPipe;
}());
exports.TNSFontIconPipe = TNSFontIconPipe;
//# sourceMappingURL=fonticon.pipe.js.map